package com.cslab.HomeApp;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class RoomSetting extends Activity implements OnClickListener {
	private int Temp_Set = 20;
	private int Humi_Set = 20;
	private Button Temp_Set_Btn;
	private Button Humi_Set_Btn;
	private String Room_Selected, RoomNum;
	static final private int Send_Diglog = 1;
	
	public static final String MYPREFS = "mySharedPreferences";
	private String ip;
	private int port;
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.setroom);
	    
	    // Intent  濡  
	    Intent i = getIntent();
	    Room_Selected = i.getStringExtra("data_room");
		
	    // û ޼ 
		if(Room_Selected.compareTo("ȹ") == 0)
			RoomNum = "Room1_set_";
		else if(Room_Selected.compareTo("Ž") == 0)
			RoomNum = "Room2_set_";
		else if(Room_Selected.compareTo("") == 0)
			RoomNum = "Room3_set_";
	    
		// Button Event Listener 
	    Button Temp_Minus = (Button)findViewById(R.id.temp_minus);
	    Button Temp_Plus = (Button)findViewById(R.id.temp_plus);
	    Button Humi_Minus = (Button)findViewById(R.id.humi_minus);
	    Button Humi_Plus = (Button)findViewById(R.id.humi_plus);
	    Button Submit_Btn = (Button)findViewById(R.id.submit);
	    Button Cancel_Btn = (Button)findViewById(R.id.cancel);
	    Temp_Set_Btn = (Button)findViewById(R.id.set_temp);
	    Humi_Set_Btn = (Button)findViewById(R.id.set_humi);
	    
	    Temp_Minus.setOnClickListener(this);
	    Temp_Plus.setOnClickListener(this);
	    Humi_Minus.setOnClickListener(this);
	    Humi_Plus.setOnClickListener(this);
	    Submit_Btn.setOnClickListener(this);
	    Cancel_Btn.setOnClickListener(this);
	    
	    // ư Text  Integer  
	    Temp_Set = Integer.parseInt((String) Temp_Set_Btn.getText());
	    Humi_Set = Integer.parseInt((String) Humi_Set_Btn.getText());
	}
	
	// Button Event
	public void onClick(View v) {
		// Client Thread
		Client client = new Client();
		// ȯ  б
		loadPreferences();
		client.set_ip_port(ip, port);
		Thread cThread = new Thread(client);
		
		// +, -   
		switch (v.getId()) {
			// - ư,  µ 
			case R.id.temp_minus:
				Temp_Set -= 1;
				Temp_Set_Btn.setText(Integer.toString(Temp_Set));
				break;
			// + ư,  µ 
			case R.id.temp_plus:
				Temp_Set += 1;
				Temp_Set_Btn.setText(Integer.toString(Temp_Set));
				break;
			// - ư,   
			case R.id.humi_minus:
				Humi_Set -= 1;
				Humi_Set_Btn.setText(Integer.toString(Humi_Set));
				break;
			// + ư,   
			case R.id.humi_plus:
				Humi_Set += 1;
				Humi_Set_Btn.setText(Integer.toString(Humi_Set));
				break;
			//    
			case R.id.submit:
				String msg = RoomNum + (String) Temp_Set_Btn.getText() + '_' 
								+ (String) Humi_Set_Btn.getText();
				client.set_string(msg);
				cThread.start();
				showDialog(Send_Diglog);
				break;
			case R.id.cancel:
				finish();
				break;
		}
	}
	
	// Nodify Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Send_Diglog) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("޼");
				Dialog_1.setMessage(Room_Selected + "  µ " + Temp_Set_Btn.getText() 
						+ "C,   " + Humi_Set_Btn.getText() + "%  Ͽϴ.");
				Dialog_1.setPositiveButton(button1_String, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						finish();
					}
				});
				return Dialog_1.create();
		}
		return null;
	}
	
	// ȯ   Load
	public void loadPreferences() {
		int mode = Activity.MODE_PRIVATE;
		SharedPreferences mySharedPreferences = getSharedPreferences(MYPREFS, mode);
		
		ip = mySharedPreferences.getString("ip", "");
		port = mySharedPreferences.getInt("port", 0);
	}
}