package com.cslab.HomeApp;

import java.util.ArrayList;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.util.Log;

public class RoomStatus extends Activity {
	/** Called when the activity is first created. */
	private static final int STATUS_ID_1 = 0;
	private static final int STATUS_ID_2 = 1;
	private Intent i;
	private Client client;
	private String Room_Selected, RoomNum, Humi, Temp, Bright;
	static final private int Failed_Diglog = 1;
	
	public static final String MYPREFS = "mySharedPreferences";
	private String ip;
	private int port;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.roomstatus1);
	    
	    // Intent  濡  
	    Intent i = getIntent();
	    TextView Room = (TextView)findViewById(R.id.Room);
	    Room_Selected = i.getStringExtra("data_room");
		Room.setText(Room_Selected);
		
		// û ޼ 
		if(Room_Selected.compareTo("ȹ") == 0)
			RoomNum = "Room1_stat";
		else if(Room_Selected.compareTo("Ž") == 0)
			RoomNum = "Room2_stat";
		else if(Room_Selected.compareTo("") == 0)
			RoomNum = "Room3_stat";
		
		// ȯ  б
		loadPreferences();
		client = new Client();
		client.set_ip_port(ip, port);
		re_frash();
	}
	
	// Menu Create
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuItem Refrash = menu.add(0, STATUS_ID_1, 0, R.string.Room_Status_Menu1);
		MenuItem AppStat = menu.add(0, STATUS_ID_2, 0, R.string.Room_Status_Menu4);
		
		Refrash.setIcon(R.drawable.refresh);
		AppStat.setIcon(R.drawable.dial);
		
		return true;
	}
	
	// Menu Event
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		super.onOptionsItemSelected(item);
		
		switch(item.getItemId()) {
			case STATUS_ID_1:
				re_frash();
				return true;
			case STATUS_ID_2:
				i = new Intent(this, RoomSetting.class);
				i.putExtra("data_room", Room_Selected);
				startActivity(i);
				return true;
		}
		return false;
	}
	
	// , ޼ ListView 
	public void re_frash() {
		// Client Thread
	    client.set_string(RoomNum);
	    Thread cThread = new Thread(client);
	    cThread.start();
	    
	    message_passing();
	    
	    // ListView 
	    ListView Status1 = (ListView)findViewById(R.id.List1);
	    
	    final ArrayList<String> StatusItem1 = new ArrayList<String>();
	    StatusItem1.add("µ : " + Temp);
	    StatusItem1.add(" : " + Humi);
	    StatusItem1.add(" : " + Bright);
	    
	    final ArrayAdapter<String> List_String1;
	    List_String1 = new ArrayAdapter<String>(this, 
	    		android.R.layout.simple_list_item_1, StatusItem1);
	    
	    Status1.setAdapter(List_String1);
	    List_String1.notifyDataSetChanged();
	}
	
	// ޼ Parsing Method
	public void message_passing() {
		String Recv_msg = client.get_string(); //   ۹ ޼
		
		// ε  ( '_' token )
		int index1 = Recv_msg.indexOf('_', 1);
		int index2 = Recv_msg.indexOf('_', index1 + 1);
		int index3 = Recv_msg.length();
		
		Log.d("MSG", Integer.toString(index2) + " " +  Integer.toString(index3));
		
		// index  ڿ 
		try{
			Temp = Recv_msg.substring(0, index1) + "C";
			Humi = Recv_msg.substring(index1 + 1, index2) + "%";
			Bright = Recv_msg.substring(index2 + 1, index3);
		}
		//  ó
		catch(Exception e)
		{
			Humi = "Not Connect";
			Temp = "Not Connect";
			Bright = "Not Connect";
			showDialog(Failed_Diglog);
		}
	}
	
	// Error Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Failed_Diglog) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("");
				Dialog_1.setMessage("  Ȱ ʽϴ.   ¸ ϼ");
				Dialog_1.setPositiveButton(button1_String, null);
				return Dialog_1.create();
		}
		return null;
	}
	
	// ȯ   Load
	public void loadPreferences() {
		int mode = Activity.MODE_PRIVATE;
		SharedPreferences mySharedPreferences = getSharedPreferences(MYPREFS, mode);
		
		ip = mySharedPreferences.getString("ip", "");
		port = mySharedPreferences.getInt("port", 0);
	}
}