// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for string functions



#pragma used+
#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);
 
unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler V2.0
// (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;


 



#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib




void lcd_char(unsigned char ch)
void lcd_char(unsigned char ch)
// LCD  
{
    PORTA.0 = 1; // D.R  
    PORTA.1 = 0;
    PORTC = ch;
    PORTA.2  = 1; // LCD ο̺
    delay_us(40);
    PORTA.2  = 0;
}

void lcd_command(unsigned char inst)
// LCD ɾ 
{
    PORTA.0 = 0; // I.R  
    PORTA.1 = 0;
    PORTC = inst;
    PORTA.2  = 1;
    delay_us(40);
    PORTA.2  = 0;
}

void lcd_str(unsigned char flash *str)
// flash  ִ str ͸ lcd_charԼ ȣϿ
// ڿ 
{
    while(*str)
    {
        lcd_char(*str);
        str++;
    }           
}

void lcd_str2(unsigned char *str)
// Ϲ ޸  ִ str ͸ lcd_charԼ ȣϿ
// ڿ 
{
    while(*str)
    {
        lcd_char(*str);
        str++;
    }           
}

void lcd_init(void)
// lcd ʱȭ
{
    lcd_command(0x38  );
    lcd_command(0x0c);
    lcd_command(0x06 );
    lcd_command(0x01 );
}

void lcd_position(unsigned char x, unsigned char y)
// ڿ  ġ 
{
    unsigned char position;
    
    if(y % 2 == 0)
    // 2 ̸̻ y  0 ó
        y = 0;
    else
        y = 1;
        
    if(x > 15)
    // 15ĭ ̸̻ x 15 ó
        x = 0;
    position = y ? x + 0xc0 : x + 0x80;
    // D.D.RAM ǥ ġ 
    // 1 ġ : 0x80, 2 ġ : 0xC0
    //  ġ  ġ ջ
    lcd_command(position);
}


unsigned char ch;
 
void port_init()
{
        DDRA = DDRC = DDRB = 0xff;
        PORTA = 0xff;
}

void main(void)
{       
        port_init();
        lcd_init();
                  
        UCSR0A = 0;    //  , U2X0  = 0
        UCSR0B = 0x98;  // ۼ ο̺, RXEN0 = TXEN0 = 1 
        // ſϷ ͷƮ ο̺ (RXCIE0 = 1)
        (*(unsigned char *) 0x95) = 0x86; // 1Ʈ  Ʈ, 񵿱  8Ʈ
                        // USBS0 = 0, UCSZ01 UCSZ00 = 1 1
        
        (*(unsigned char *) 0x90) = 0; // Ʈ 9600bps
        UBRR0L = 23; // echo print,  ۽
        SREG = 0x80;
        
        while(1)
			// LCD ǥ
        {
                //lcd_command(0x80);    
                //lcd_str("* Room Status *");
                //lcd_command(0xc0);
                
                //delay_ms(2000);
        }
} 

interrupt[19] void usart0_rxc(void) // 
{
    ch = UDR0;
    lcd_char(ch);
    if(ch == '1')
        PORTB = PORTB | 0x01;
    else if(ch == '2')
        PORTB = PORTB & 0xfe;
    else if(ch == '3')
        PORTB = PORTB | 0x02;
    else if(ch == '4')
        PORTB = PORTB & 0xfd;
    else if(ch == '5')
        PORTB = PORTB | 0x04;
    else if(ch == '6')
        PORTB = PORTB & 0xfb; 
    else if(ch == '9')
        PORTB = PORTB | 0x08;
    else if(ch == '0')
        PORTB = PORTB & 0xf7; 
    else if(ch == 'a')
        PORTB = PORTB | 0x10;
    else if(ch == 'b')
        PORTB = PORTB & 0xef; 
    else if(ch == 'c')
        PORTB = PORTB | 0x20;
    else if(ch == 'd')
        PORTB = PORTB & 0xdf;
    else if(ch == '7')
        PORTB = PORTB | 0x07;
    else if(ch == '8')
        PORTB = PORTB & 0x38;
    else if(ch == 'e')
        PORTB = PORTB | 0x38;
    else if(ch == 'f')
        PORTB = PORTB & 0x07; 
    
    UCSR0B |= 0x20; // ۽  empty ͷƮ  UDRIE = 1 
}

interrupt[20] void usart0_dre(void) // ۽
{
        UDR0 = ch; // ŵ ch USART ۽ ۿ 
        UCSR0B &= 0xdf; // ۽  empty ͷƮ  UDRIE = 0;
}
