/////////////////////////////////////////////////////////////////////////////////////
// CCI-API Լ ( DB , ڵ ȸ, ,  )
/////////////////////////////////////////////////////////////////////////////////////

//  
#include "CUBRID.h"
#include "Common.h"

//  
int manage_data(int con, char *sql)
{
	int	req, res;
	//char sql[BUF_SIZE+1];
	T_CCI_ERROR	error;

	//   Ѵ.
	if ((req = cci_prepare(con, sql, 0, &error)) < 0) {
		//  ߻  ڵ ޼ Ѵ.
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		//  ߻ϿǷ ѹóѴ
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);

		return 0;
	}

	// Ǹ Ѵ.
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	//   óǾǷ Ŀ óѴ.
	if (cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0) {
		// Է Ŀ ̹Ƿ ˷ Ѵ.
		printf("COMMIT ERROR [%d] %s\n", error.err_code, error.err_msg);
		return 0;
	}
}

// ͸ ԷѴ
int insert_data(int con, int room_num, int *num, float *temputure, float *humidity, char *bright)
{
	int	req, res;
	char	sql[BUF_SIZE+1];
	char	buf[BUF_SIZE+1];
	T_CCI_ERROR	error;

	sprintf(sql, ROOM_INSERT, room_num);

	//   Ѵ.
	if ((req = cci_prepare(con, sql, 0, &error)) < 0) {
		//  ߻  ڵ ޼ Ѵ.
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		//  ߻ϿǷ ѹóѴ
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);

		return 0;
	}

	// ? κп   ҴѴ.
	if ((res = cci_bind_param(req, 1, CCI_A_TYPE_INT, (void **)num, CCI_U_TYPE_INT, (int)NULL)) < 0) {
		cci_get_err_msg (res, buf, BUF_SIZE);
		printf("bind error 1 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	if ((res = cci_bind_param(req, 2, CCI_A_TYPE_FLOAT, (void **)temputure, CCI_U_TYPE_FLOAT, (int)NULL)) < 0) {
		cci_get_err_msg (res, buf, BUF_SIZE);
		printf("bind error 2 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	if ((res = cci_bind_param(req, 3, CCI_A_TYPE_FLOAT, (void **)humidity, CCI_U_TYPE_FLOAT, (int)NULL)) < 0) {
		cci_get_err_msg (res, buf, BUF_SIZE);
		printf("bind error 3 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	if ((res = cci_bind_param(req, 4, CCI_A_TYPE_STR, (void *)bright, CCI_U_TYPE_STRING, (int)NULL)) < 0) {
		cci_get_err_msg (res, buf, BUF_SIZE);
		printf("bind error 4 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	// Ǹ Ѵ.
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	//   óǾǷ Ŀ óѴ.
	if (cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0) {
		// Է Ŀ ̹Ƿ ˷ Ѵ.
		printf("COMMIT ERROR [%d] %s\n", error.err_code, error.err_msg);
		return 0;
	}

	return 1;
}

// select_data_status :   ȸ
// select_data_control :   ȸ
// select_data_setting : ǳ  ȸ

// Ǹ Ͽ data ´.
int select_data_status(int con, char *sql, double *pTemp, double *pHumi, char **pLight)
{
	int	req, res, i, ind, col_count;
		// OID   select  ʵ  ̺ ̸ Ѵ.
	char	*buf;
	char	code[4], name[41];
	T_CCI_ERROR	error;
	T_CCI_COL_INFO *res_col_info;
	T_CCI_SQLX_CMD cmd_type;
	char *buffer;

	double temp_avr = 0.0, humi_avr = 0.0;
	int nCount = 0;

	//   Ѵ.
	if ((req = cci_prepare(con, sql, 0, &error)) < 0) {
		//  ߻  ڵ ޼ Ѵ.
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		//  ߻ϿǷ ѹóѴ
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);

		return 0;
	}
	
	// ÷  Ѵ
	res_col_info = cci_get_result_info(req, &cmd_type, &col_count);
    if (!res_col_info) {
        printf( "%s(%d): cci_get_result_info fail\n", __FILE__, __LINE__);
    }

	printf("Result column information\n"   
		   "========================================\n");
	//  ÷  
    for (i=1; i<=col_count; i++) {
        printf("name:%s  type:%d(precision:%d scale:%d)\n",
            CCI_GET_RESULT_INFO_NAME(res_col_info, i),
			// ÷ ̸
            CCI_GET_RESULT_INFO_TYPE(res_col_info, i),
			// ÷ 
            CCI_GET_RESULT_INFO_PRECISION(res_col_info, i),
			// ÷ precision
            CCI_GET_RESULT_INFO_SCALE(res_col_info, i));
			// ÷ 
    }
	printf("========================================\n");

	// Ǹ Ѵ.
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	//  Ʃ  
	if ((res=cci_fetch_size(req, 100))<0) {
        printf( "%s(%d): cci_fetch_size fail\n", __FILE__, __LINE__);
    }

	//    ó ̵Ѵ.
	while(1) {
		res = cci_cursor(req, 1, CCI_CURSOR_CURRENT, &error);
		//  Ŀ 
		if (res == CCI_ER_NO_MORE_DATA) { // ̻ Ͱ  
            printf("Query END!\n");
            break;
        }
		//  Ŀ  
		if (res<0) {
            printf( "%s(%d): cci_cursor fail(%d)\n", __FILE__, __LINE__,error.err_code);
			break;
        }
		//  fetch   
		if ((res=cci_fetch(req, &error))<0) {
            printf( "%s(%d): cci_fetch fail(%d)\n", __FILE__, __LINE__,error.err_code);
            break;
        }
		
		// ڵ 
		for (i=1; i<=col_count; i++) { 
            if ((res=cci_get_data(req, i, CCI_A_TYPE_STR, &buffer, &ind))<0) {
                printf( "%s(%d): cci_get_data fail\n", __FILE__, __LINE__);
            }
            //printf("%s \t|", buffer);
			if(i == 1)
				nCount = atoi(buffer);
			else if(i == 2)
				temp_avr += atof(buffer);
			else if(i == 3)
				humi_avr += atof(buffer);
			else if(i == 4)
				strcpy(*pLight, buffer);
        }
		//printf("\n");
	}

	*pTemp = temp_avr / nCount;
	*pHumi = humi_avr / nCount;

	//      Ҵ ޸𸮸 Ѵ.
	cci_close_req_handle(req);

	cci_end_tran(con, CCI_TRAN_COMMIT, &error);

	return 1;
}

int select_data_control(int con, char *sql, char **pCon1, char **pCon2, char **pCon3)
{
	int	req, res, i, ind, col_count;
		// OID   select  ʵ  ̺ ̸ Ѵ.
	char	*buf;
	char	code[4], name[41];
	T_CCI_ERROR	error;
	T_CCI_COL_INFO *res_col_info;
	T_CCI_SQLX_CMD cmd_type;
	char *buffer;

	//   Ѵ.
	if ((req = cci_prepare(con, sql, 0, &error)) < 0) {
		//  ߻  ڵ ޼ Ѵ.
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		//  ߻ϿǷ ѹóѴ
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);

		return 0;
	}
	
	// ÷  Ѵ
	res_col_info = cci_get_result_info(req, &cmd_type, &col_count);
    if (!res_col_info) {
        printf( "%s(%d): cci_get_result_info fail\n", __FILE__, __LINE__);
    }

	/*printf("Result column information\n"   
		   "========================================\n");
	//  ÷  
    for (i=1; i<=col_count; i++) {
        printf("name:%s  type:%d(precision:%d scale:%d)\n",
            CCI_GET_RESULT_INFO_NAME(res_col_info, i),
			// ÷ ̸
            CCI_GET_RESULT_INFO_TYPE(res_col_info, i),
			// ÷ 
            CCI_GET_RESULT_INFO_PRECISION(res_col_info, i),
			// ÷ precision
            CCI_GET_RESULT_INFO_SCALE(res_col_info, i));
			// ÷ 
    }
	printf("========================================\n");*/

	// Ǹ Ѵ.
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	// ۷  ޴´.
	if ((res=cci_fetch_size(req, 100))<0) {
        printf( "%s(%d): cci_fetch_size fail\n", __FILE__, __LINE__);
    }

	//    ó ̵Ѵ.
	while(1) {
		res = cci_cursor(req, 1, CCI_CURSOR_CURRENT, &error);
		//  Ŀ 
		if (res == CCI_ER_NO_MORE_DATA) { // ̻ Ͱ  
            printf("Query END!\n");
            break;
        }
		//  Ŀ  
		if (res<0) {
            printf( "%s(%d): cci_cursor fail(%d)\n", __FILE__, __LINE__,error.err_code);
			break;
        }
		//  fetch   
		if ((res=cci_fetch(req, &error))<0) {
            printf( "%s(%d): cci_fetch fail(%d)\n", __FILE__, __LINE__,error.err_code);
            break;
        }
		
		// ڵ 
		for (i=1; i<=col_count; i++) { 
            if ((res=cci_get_data(req, i, CCI_A_TYPE_STR, &buffer, &ind))<0) {
                printf( "%s(%d): cci_get_data fail\n", __FILE__, __LINE__);
            }
            //printf("%s \t|", buffer);
			if((i == 2) && (*pCon1 != NULL))
				strcpy(*pCon1, buffer);
			else if((i == 3) && (*pCon2 != NULL))
				strcpy(*pCon2, buffer);
			else if((i == 4) && (*pCon3 != NULL))
				strcpy(*pCon3, buffer);
        }
		printf("\n");
	}

	//      Ҵ ޸𸮸 Ѵ.
	cci_close_req_handle(req);

	cci_end_tran(con, CCI_TRAN_COMMIT, &error);

	return 1;
}

int select_data_setting(int con, char *sql, int *temp, int *humi)
{
	int	req, res, i, ind, col_count;
		// OID   select  ʵ  ̺ ̸ Ѵ.
	char	*buf;
	char	code[4], name[41];
	T_CCI_ERROR	error;
	T_CCI_COL_INFO *res_col_info;
	T_CCI_SQLX_CMD cmd_type;
	char *buffer;

	//   Ѵ.
	if ((req = cci_prepare(con, sql, 0, &error)) < 0) {
		//  ߻  ڵ ޼ Ѵ.
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		//  ߻ϿǷ ѹóѴ
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);

		return 0;
	}
	
	// ÷  Ѵ
	res_col_info = cci_get_result_info(req, &cmd_type, &col_count);
    if (!res_col_info) {
        printf( "%s(%d): cci_get_result_info fail\n", __FILE__, __LINE__);
    }

	/*printf("Result column information\n"   
		   "========================================\n");
	//  ÷  
    for (i=1; i<=col_count; i++) {
        printf("name:%s  type:%d(precision:%d scale:%d)\n",
            CCI_GET_RESULT_INFO_NAME(res_col_info, i),
			// ÷ ̸
            CCI_GET_RESULT_INFO_TYPE(res_col_info, i),
			// ÷ 
            CCI_GET_RESULT_INFO_PRECISION(res_col_info, i),
			// ÷ precision
            CCI_GET_RESULT_INFO_SCALE(res_col_info, i));
			// ÷ 
    }
	printf("========================================\n");*/

	// Ǹ Ѵ.
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("prepare error[%d] %s\n SQL: %s\n", error.err_code, error.err_msg, sql);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}

	// ۷  ޴´.
	if ((res=cci_fetch_size(req, 100))<0) {
        printf( "%s(%d): cci_fetch_size fail\n", __FILE__, __LINE__);
    }

	//    ó ̵Ѵ.
	while(1) {
		res = cci_cursor(req, 1, CCI_CURSOR_CURRENT, &error);
		//  Ŀ 
		if (res == CCI_ER_NO_MORE_DATA) { // ̻ Ͱ  
            printf("Query END!\n");
            break;
        }
		//  Ŀ  
		if (res<0) {
            printf( "%s(%d): cci_cursor fail(%d)\n", __FILE__, __LINE__,error.err_code);
			break;
        }
		//  fetch   
		if ((res=cci_fetch(req, &error))<0) {
            printf( "%s(%d): cci_fetch fail(%d)\n", __FILE__, __LINE__,error.err_code);
            break;
        }
		
		// ڵ 
		for (i=1; i<=col_count; i++) { 
            if ((res=cci_get_data(req, i, CCI_A_TYPE_STR, &buffer, &ind))<0) {
                printf( "%s(%d): cci_get_data fail\n", __FILE__, __LINE__);
            }
            //printf("%s \t|", buffer);
			if(i == 2)
				*temp = atoi(buffer);
			else if(i == 3)
				*humi = atoi(buffer);
        }
		printf("\n");
	}

	//      Ҵ ޸𸮸 Ѵ.
	cci_close_req_handle(req);

	cci_end_tran(con, CCI_TRAN_COMMIT, &error);

	return 1;
}

int DB_Connect()
{
	int	con = 0; // connection handle
	char	oid[39]; // OID   . OID ̴ 38
	int	res;
	char	buf[BUF_SIZE+1];

	// cci_connect()  ̿Ͽ ͺ̽ Ѵ.
	//  (localhost) 33000(⺻ ־ Ʈ) Ѵ.
	// ͺ̽ ⺻ ϴ demodb ̿ϰ,
	// ڴ ⺻ PUBLIC  ̿Ѵ. ȣ   Ͽ "" Ѵ.
	if ((con = cci_connect(DB_HOST, DB_PORT, DB_NAME, DB_USER, DB_PASSWD)) < 0) {
		printf("localhost demodb connection error\n");
		return 0;
	}
	//  cci_connect()    ʴ´. CUBRID (3-tier) Ḹ ̸ س 
	// ٸ  ϴ  connection   δ Ŀ  database ۾    Ѵ.
	//   Ȯϱ ؼ  ͺ̽   ȴ.
	if ((res = cci_get_db_version(con, buf, BUF_SIZE)) < 0) {
		cci_get_err_msg (res, buf, BUF_SIZE);
		printf("get version error : %d, %s\n", res, buf);
		return 0;
	} else
		printf("database version : %s\n", buf);
	return con;
}

void DB_Disconnect(int con, T_CCI_ERROR error)
{
	// cci_disconnect()  ̿Ͽ ͺ̽  Ѵ.
	cci_disconnect(con, &error);
}